/*
 ķ
   Program..: _DCQOUT.PRG                           
   Author...: Roger J. Donnay                       
   Notice...: (c) DONNAY Software Designs 1987-2001 
   Date.....: June 29, 2001                         
   Notes....: Qout() functions for eXPress++        
                                                    
   Functions: dc_qout(), dc_qqout()                 
 Ľ
*/

#INCLUDE "dcicon.CH"
#INCLUDE "dcdialog.CH"
#INCLUDE "dcprint.CH"
#include "fileio.ch"
#INCLUDE "appevent.CH"
#INCLUDE "dcbitmap.CH"
#INCLUDE "dll.CH"
#INCLUDE "thread.CH"

STATIC oDlgWindow := nil, saDebugWindow := {}, soMenu, soBrowse

FUNCTION dc_qoutwindow ( oCrt, bEval, lSetWindow )

LOCAL oParent, nCol, nRow, oOldCrt, oOldFocus := SetAppFocus()

STATIC oCrtWindow := nil

oOldCrt := oCrtWindow

lSetWindow := IIF(Valtype(lSetWindow)='L',lSetWindow,.f.)

IF Valtype( oCrt ) = 'O' .AND. oCrt:ClassName() = 'XbpCrt'

  oCrtWindow := oCrt

ELSEIF Valtype(oCrtWindow) # 'O' .OR. oCrtWindow:ClassName() # 'XbpCrt'

   // First active SetAppWindow() == Desktop
   oParent := AppDesktop ( SetAppWindow() )
   nCol := (oParent:currentSize()[1]-620)/2
   nRow := (oParent:currentSize()[2]-400)/2

   // Create XbpCRT object
   oCrtWindow := XbpCrt():New ( oParent, NIL, { nCol, nRow }, 25, 80 )
   oCrtWindow:FontWidth  := 8
   oCrtWindow:FontHeight := 12
   oCrtWindow:FontName   := "Terminal"
   oCrtWindow:Title      := "eXPress++ CRT Window"
   oCrtWindow:icon := ICON_EXPRESS

   oCrtWindow:Create()

   // Init Presentation Space
   oCrtWindow:PresSpace()

   IF Valtype(bEval) = 'B'
     Eval( bEval, oCrtWindow )
   ENDIF

   oOldCrt := oCrtWindow

ENDIF

IF Valtype(oOldFocus) = 'O'
  SetAppFocus( oOldFocus )
ENDIF

// XbpCrt gets active window and output device
IF lSetWindow .AND. Valtype(oCrtWindow)='O' .AND. oCrtWindow:ClassName()=="XbpCrt"
  SetAppWindow ( oCrtWindow )
ENDIF

RETURN oOldCrt

* ---------------

FUNCTION dc_qout ( xText )

DC_QQout( Chr(13)+Chr(10) )
DC_QQout( xText )

RETURN nil

* ----------------

FUNCTION dc_qqout ( xText )

LOCAL oAppWindow := SetAppWindow()

IF Valtype(DC_QoutWindow()) = 'O'
  SetAppWindow( DC_QoutWindow())
  __QQout( xText )
ELSEIF Valtype(oAppWindow) = 'O' .AND. oAppWindow:ClassName() = 'XbpCrt'
  __QQout( xText )
ENDIF

SetAppWindow( oAppWindow )

RETURN nil

* ---------------

STATIC FUNCTION __QQout ( xText )

LOCAL i

IF Valtype( xText ) # 'A'
  xText := { xText }
ENDIF
FOR i := 1 TO Len(xText)
  ?? xText[i], ''
NEXT
RETURN nil

* -------------------

PROCEDURE DC_QoutCallStack( nOccur, lWait )

LOCAL i := 1
DEFAULT nOccur := 100, lWait := .f.
DO WHILE .t.
  DCQOUT "Called from " + Trim(ProcName(i)) + ;
       "(" + Alltrim(Str(ProcLine(i))) + ")"
  i++
  IF Empty(ProcName(i)) .OR. i > nOccur
     EXIT
  ENDIF
ENDDO
IF lWait
  MsgBox('Press any key...')
ENDIF

RETURN

* -----------

FUNCTION DC_WtfEnable( aEnable )

STATIC saEnable
LOCAL aOldEnable
IF Valtype(saEnable) == 'A'
  aOldEnable := AClone(saEnable)
ENDIF
IF PCount() = 1 .AND. Valtype(aEnable) $ 'UA'
  saEnable := aEnable
ENDIF

RETURN aOldEnable

* -----------

FUNCTION dc_debugwindow ( oDlg, bEval )

LOCAL oParent, oOldDlg, oMemoWindow, nHeightDelta, nEvent, mp1, mp2, oXbp, ;
      oPrintButton

oOldDlg := oDlgWindow

IF Valtype( oDlg ) = 'O' .AND. oDlg:IsDerivedFrom('XbpDialog')

  oDlgWindow := oDlg

ELSEIF Valtype(oDlgWindow) # 'O' .OR. !(oDlgWindow:isDerivedFrom('XbpDialog'))

   oParent := AppDesktop()

   oDlgWindow := XbpDialog():New ( oParent,, { 0, 0 }, ;
                 {AppDeskTop():currentSize()[1], 300},, .t. )
   oDlgWindow:Title      := "eXPress++ Debug Window"
   oDlgWindow:icon := ICON_EXPRESS
   oDlgWindow:tasklist := .t.
   oDlgWindow:minButton := .t.
   oDlgWindow:maxButton := .t.
   oDlgWindow:close := {||oDlgWindow:destroy(),oDlgWindow := nil}
   oDlgWindow:resize := {|a,b,o|_Resize(a,b,o,oMemoWindow,nHeightDelta)}

   oDlgWindow:Create()

   nHeightDelta := oDlgWindow:currentSize()[2]-oDlgWindow:drawingArea:currentSize()[2] + 60

   oMemoWindow := XbpMle():new(oDlgWindow:drawingArea,,{5,45},{270,300-nHeightDelta},,.t.)
   oMemoWindow:create()
   oMemoWindow:setFontCompoundName('8.Terminal')
   oDlgWindow:cargo := oMemoWindow

   oPrintButton := XbpPushButton():new(oDlgWindow:drawingArea,,{5,5},{60,22},,.t.)
   oPrintButton:activate := {||_PrintMemo(oMemoWindow:editBuffer())}
   oPrintButton:caption := 'Print'
   oPrintButton:create()

   IF Valtype(bEval) = 'B'
     Eval( bEval, oDlgWindow )
   ENDIF

   oOldDlg := oDlgWindow
   oDlg := oDlgWindow

   DO WHILE Valtype(oDlgWindow) == 'O'
     nEvent := Appevent(@mp1,@mp2,@oXbp,10)
     IF Valtype(oXbp)='O'
       oXbp:HandleEvent( nEvent, mp1, mp2 )
     ENDIF
   ENDDO

ENDIF

RETURN oOldDlg

* ---------------------

FUNCTION DC_DebugQoutAppendBlock( bBlock )

STATIC sbBlock := {||' <- Called From: ' + ;
               ProcName(2) + '('+Alltrim(Str(ProcLine(2)))+'), ' + ;
               ProcName(3) + '('+Alltrim(Str(ProcLine(3)))+'), ' + ;
               ;//ProcName(4) + '('+Alltrim(Str(ProcLine(4)))+'), ' + ;
               ;//ProcName(5) + '('+Alltrim(Str(ProcLine(5)))+'), ' + ;
               ;//ProcName(6) + '('+Alltrim(Str(ProcLine(6)))+'), ' + ;
               ProcName(4) + '('+Alltrim(Str(ProcLine(3)))+')' }

LOCAL bOldBlock := sbBlock

IF Valtype(bBlock) == 'B'
  sbBlock := bBlock
ENDIF

RETURN bOldBlock

* ---------------------

FUNCTION dc_debugqout ( xText, lAppendBlock )

LOCAL bAppend, cString

DEFAULT lAppendBlock := .t.

IF PCount() == 0
  DC_DebugQQout()
ELSE
  DC_DebugQQout( Chr(13)+Chr(10) )
  DC_DebugQQout( xText )
  IF lAppendBlock
    bAppend := DC_DebugQoutAppendBlock()
  ELSE
    bAppend := {||''}
  ENDIF
  IF Valtype(bAppend) == 'B'
    cString := Eval(bAppend)
    DC_DebugQQout( cString )
  ENDIF
ENDIF

RETURN nil

* ---------------------

FUNCTION dc_debugqqout ( xText )

LOCAL i, oDlg, oMemoWindow, cText, nBufferLen, oThread

IF Valtype(oDlgWindow) = 'O'
  oDlg := oDlgWindow
ELSE
  oThread := Thread():new()
  Sleep(20)
  oThread:start( {||DC_DebugWindow(@oDlg)} )
  DO WHILE Valtype(oDlg) # 'O'
    Sleep(10)
  ENDDO
ENDIF

oMemoWindow := oDlg:cargo

IF PCount() == 0
  oMemoWindow:setData('')
ELSE
  IF Valtype( xText ) # 'A'
    xText := { xText }
  ENDIF
  cText := oMemoWindow:editBuffer()
  nBufferLen := Len(cText)
  FOR i := 1 TO Len(xText)
    cText += Var2Char(xText[i]) + ' '
  NEXT
  IF Len(cText) > 20000
    cText := SubStr(cText,Len(cText)-20000)
  ENDIF
  oMemoWindow:setData(cText)
  oMemoWindow:setFirstChar(nBufferLen+1)
ENDIF

RETURN nil

* ---------------------

FUNCTION DC_DebugLogOut ( xText, lAppendBlock, lInspectObject )

LOCAL bAppend, cString, cFileName, i

DEFAULT lAppendBlock := .t., ;
        lInspectObject := .f.

IF PCount() == 0
  _DebugLogOut()
ELSE
  _DebugLogOut( Chr(13)+Chr(10) )
  _DebugLogOut( xText, lInspectObject )
  IF lAppendBlock
    bAppend := DC_DebugLogAppendBlock()
  ELSE
    bAppend := {||''}
  ENDIF
  IF Valtype(bAppend) == 'B'
    cString := Eval(bAppend)
    _DebugLogOut( cString, lInspectObject )
  ENDIF
  IF lInspectObject
    cFileName := DC_DebugLogFile()
    IF Valtype(xText) == 'O'
      DC_InspectObject2File( xText, cFileName )
    ELSEIF Valtype(xText) == 'A'
      FOR i := 1 TO Len(xText)
        IF Valtype(xText[i]) == 'O'
          DC_InspectObject2File( xText[i], cFileName )
        ENDIF
      NEXT
    ENDIF
  ENDIF
ENDIF

RETURN nil

* ---------------------

STATIC FUNCTION _DebugLogOut ( xText, lInspectObject )

LOCAL i, nHandle, cText := '', cFileName, oXbp

DEFAULT lInspectObject := .f.

IF Valtype( xText ) # 'A'
  xText := { xText }
ELSEIF Valtype(xText) == 'O'
  oXbp := xText
ENDIF
FOR i := 1 TO Len(xText)
  cText += Var2Char(xText[i]) + ' '
NEXT

cFileName := DC_DebugLogFile()

IF FExists(cFileName)
  DO WHILE (nHandle := FOpen(cFileName, FO_WRITE + FO_DENYWRITE)) < 0
    IF ++i > 9
      RETURN .f.
    ENDIF
    Sleep(20)
  ENDDO
  FSeek(nHandle, 0, FS_END)  // position to end of file
ELSE
  DO WHILE (nHandle := FCreate(cFileName)) < 0
    IF ++i > 9
      RETURN .f.
    ENDIF
    Sleep(20)
  ENDDO
ENDIF

FSeek( nHandle, 0, FS_END )
FWrite( nHandle, cText )
FClose( nHandle )

RETURN .t.

* ---------------------

FUNCTION DC_DebugLogAppendBlock( bBlock )

STATIC sbBlock := {||' <- Called From: ' + ;
               ProcName(2) + '('+Alltrim(Str(ProcLine(2)))+'), ' + ;
               ProcName(3) + '('+Alltrim(Str(ProcLine(3)))+'), ' + ;
               ProcName(4) + '('+Alltrim(Str(ProcLine(4)))+'), ' + ;
               ProcName(5) + '('+Alltrim(Str(ProcLine(5)))+'), ' + ;
               ProcName(6) + '('+Alltrim(Str(ProcLine(6)))+'), ' + ;
               ProcName(7) + '('+Alltrim(Str(ProcLine(7)))+'), ' + ;
               ProcName(8) + '('+Alltrim(Str(ProcLine(8)))+'), ' + ;
               ProcName(9) + '('+Alltrim(Str(ProcLine(9)))+'), ' + ;
               ProcName(10) + '('+Alltrim(Str(ProcLine(10)))+'), ' + ;
               ProcName(11) + '('+Alltrim(Str(ProcLine(11)))+'), ' + ;
               ProcName(12) + '('+Alltrim(Str(ProcLine(12)))+'), ' + ;
               DC_XtoC(Date()) + ' ' + Time()}

LOCAL bOldBlock := sbBlock

IF Valtype(bBlock) == 'B'
  sbBlock := bBlock
ENDIF

RETURN bOldBlock

* ---------------------

GETSETFUNCTION dc_debuglogfile DEFAULT 'DEBUG.LOG'

* -------------------

STATIC PROCEDURE _ReSize(a,b,o,oMemoWindow,nHeightDelta)

oMemoWindow:setSize({o:currentSize()[1]-20,o:currentSize()[2]-nHeightDelta})

RETURN

* -------------------

STATIC PROCEDURE _PrintMemo( cMemo )

LOCAL nLineCount, i, cMemoLine, oPrinter, nLine

DCPRINT ON PREVIEW NONSTOP HIDE FONT '8.Courier New' TO oPrinter
nLineCount := MLCount(cMemo)
nLine := 0
FOR i := 1 TO nLineCount - 1
  cMemoLine := MemoLine( cMemo, nil, i )
  @ nLine,1 DCPRINT SAY cMemoLine PRINTER oPrinter
  nLine++
  IF nLine > 59
    nLine := 0
    DCPRINT EJECT PRINTER oPrinter
  ENDIF
NEXT
DCPRINT OFF PRINTER oPrinter
RETURN

* ---------------------

FUNCTION DC_DebugBrowseConfig( nWindow, aConfig )

STATIC saConfig := {}
LOCAL aOldConfig

DEFAULT nWindow := 1
IF nWindow > Len(saConfig)
  ASize(saConfig,nWindow)
ENDIF
IF Empty(saConfig[nWindow])
  saConfig[nWindow] := _DefaultConfig()
ENDIF
aOldConfig := saConfig[nWindow]
IF Valtype(aConfig) == 'A'
  saConfig[nWindow] := aConfig
ENDIF

RETURN aOldConfig

* ---------------------

STATIC FUNCTION _DefaultConfig()

RETURN { ;
   {'Row', ;
    'b', ;
    'Data', ;
    'Source;Expr', ;
    'Val;Type', ;
    'Stack;1', ;
    'Stack;2', ;
    'Stack;3', ;
    'Stack;4', ;
    'Stack;5', ;
    'Stack;6', ;
    'Stack;7', ;
    'Stack;8', ;
    'Stack;9', ;
    'Date', ;
    'Time'}, ;
   { 6, ;
     2, ;
     12, ;
     12, ;
     5, ;
     10, ;
     5, ;
     5, ;
     5, ;
     5, ;
     5, ;
     5, ;
     5, ;
     5, ;
     5, ;
     5 }, ;
   { nil, ;
     .f., ;
     nil, ;
     nil, ;
     nil, ;
     {||ProcName(2)+'('+Alltrim(Str(ProcLine(2)))+')'}, ;
     {||ProcName(3)+'('+Alltrim(Str(ProcLine(3)))+')'}, ;
     {||ProcName(4)+'('+Alltrim(Str(ProcLine(4)))+')'}, ;
     {||ProcName(5)+'('+Alltrim(Str(ProcLine(5)))+')'}, ;
     {||ProcName(6)+'('+Alltrim(Str(ProcLine(6)))+')'}, ;
     {||ProcName(7)+'('+Alltrim(Str(ProcLine(7)))+')'}, ;
     {||ProcName(8)+'('+Alltrim(Str(ProcLine(8)))+')'}, ;
     {||ProcName(9)+'('+Alltrim(Str(ProcLine(9)))+')'}, ;
     {||ProcName(10)+'('+Alltrim(Str(ProcLine(10)))+')'}, ;
     {||Date()}, ;
     {||Time()} } ;
   }

* ---------------------

FUNCTION DC_DebugBrowse ( aData, aExpr, nWindow, nbFgColor, nBgColor, lbPause, ;
                          lAlwaysOnTop, bWhen )

LOCAL i, j, aBrowData, oBrowse, oDlg, oThread, aConfig, nEvent, aDebugEnable, ;
      mp1, mp2, oXbp, oContinueButton, oAppFocus, lDebugEnable := .F., ;
      lOverRide, aEnable := DC_WtfEnable(), cValue, oCallWindow

IF Valtype(aEnable) = 'A' .AND. Len(aEnable) == 2
  cValue := GetEnv(aEnable[1])
  IF !cValue==aEnable[2]
    RETURN nil
  ENDIF
ENDIF

IF IsMemVar('__DCBDEBUG') .AND. M->__DCBDEBUG
  RETURN nil
ENDIF

DEFAULT nWindow := ThreadID()

oThread := ThreadObject()
IF oThread:isDerivedFrom('DC_Thread')
  oCallWindow := oThread:xbp
ENDIF

aDebugEnable := DC_DebugBrowseEnable()
IF !Empty(aDebugEnable)
  FOR i := 1 TO Len(aDebugEnable)
    IF ' ' + Upper(GetEnv(aDebugEnable[i])) + ' ' $ ' YES ON JA HO '
      lDebugEnable := .T.
    ENDIF
  NEXT
ELSE
  lDebugEnable := .T.
ENDIF

IF !lDebugEnable
  RETURN nil
ELSEIF Valtype(bWhen) == 'B' .AND. !Eval(bWhen)
  RETURN nil
ENDIF

DEFAULT nWindow := 1
oBrowse := _debugBrowseWindow( nWindow, @oDlg, lAlwaysOnTop, oCallWindow )

IF oBrowse:setParent():cargo[5] // suspended?
  RETURN nil
ENDIF

oContinueButton := oDlg:drawingArea:cargo[2]
lOverRide := oDlg:drawingArea:cargo[4]
aConfig := DC_DebugBrowseConfig(nWindow)
aBrowData := Array(Len(aConfig[1]))
DEFAULT aExpr := {}
ASize(aExpr,Len(aData))
FOR i := 1 TO Len(aData)
  aBrowData := Array(Len(aConfig[1]))
  aBrowData[1] := Len(oBrowse:dataSource) + 1
  aBrowData[2] := .f.
  aBrowData[3] := Var2Char(aData[i])
  aBrowData[4] := DC_XtoC(aExpr[i])
  aBrowData[5] := Valtype(aData[i])
  FOR j := 6 TO Len(aBrowData)
    aBrowData[j] := Eval(aConfig[3,j])
  NEXT
  AAdd(aBrowData,{nbFgColor,nBgColor})
  AAdd(aBrowData,aData[i])
  AAdd(oBrowse:dataSource,aBrowData)
NEXT
oBrowse:goBottom()
oBrowse:forceStable()

IF !lOverRide .AND. (Valtype(lbPause) == 'B' .AND. Eval(lbPause)) .OR. ;
   (Valtype(lbPause) == 'L' .AND. lbPause)
  oDlg:drawingArea:cargo[3] := .f.
  oContinueButton:enable()
  oAppFocus := SetAppFocus(oContinueButton)
  DO WHILE oContinueButton:status() > 0
    nEvent := AppEvent(@mp1,@mp2,@oXbp,50)
    IF nEvent > 0 .AND. Valtype(oXbp) == 'O'
      oXbp:handleEvent(nEvent,mp1,mp2)
    ENDIF
    IF oDlg:drawingArea:cargo[3] .OR. nEvent == xbeP_Close .OR. lOverRide
      EXIT
    ENDIF
  ENDDO
  oContinueButton:disable()
  SetAppFocus(oAppFocus)
ENDIF

RETURN nil

* --------------------

STATIC FUNCTION _DebugBrowseWindow( nWindow, oDlg, lAlwaysOnTop, oCallWindow )

LOCAL oBrowse, oThread

DEFAULT nWindow := 1

IF nWindow > Len(saDebugWindow)
  ASize(saDebugWindow,nWindow)
ENDIF

IF Valtype(saDebugWindow[nWindow]) = 'O'
  oDlg := saDebugWindow[nWindow]
ELSE
  oThread := Thread():new()
  Sleep(20)
  oThread:start( {||DC_DebugWindowBrowse(@oDlg,nWindow,nil,lAlwaysOnTop,oCallWindow)} )
  DO WHILE Valtype(oDlg) # 'O'
    Sleep(10)
  ENDDO
  saDebugWindow[nWindow] := oDlg
ENDIF

oBrowse := oDlg:drawingArea:cargo[1]

RETURN oBrowse

* --------------------

STATIC FUNCTION _DebugRestore( oBrowse, nWindow )

LOCAL GetList[0], GetOptions, cFileName, lStatus

cFileName := Space(70)

@ 0,0 DCSAY 'File Name to Restore from:' SAYSIZE 0 SAYBOTTOM
@ 1,0 DCGET cFileName POPUP {|c|DC_PopFile(c,,,'Debug file to Restore')} VALID {||DC_ReadEmpty(cFileName)}

@ 3,0 DCSAY 'Window #' GET nWindow PICTURE '9' SAYSIZE 0 SAYBOTTOM

DCGETOPTIONS TABSTOP

DCREAD GUI FIT MODAL SETAPPWINDOW TITLE 'Restore Debug from File' ;
   TO lStatus ADDBUTTONS ENTEREXIT NOAUTORESTORE OPTIONS GetOptions

IF lStatus
  DC_DebugBrowseRestore( Alltrim(cFileName), nWindow)
ENDIF

RETURN nil

* --------------------

FUNCTION DC_DebugBrowseRestore( cFileName, nWindow )

LOCAL oBrowse, oDlg, aData, cBuffer, nHandle, nBytes

DEFAULT nWindow := 1
DEFAULT cFileName := 'DCBDEBUG.XPF'
IF !'.' $ cFileName
  cFileName += '.XPF'
ENDIF

IF File(cFileName)
  nHandle := FOpen(cFileName)
  nBytes := FSeek( nHandle, 0, FS_END )
  FSeek(nHandle,0,FS_SET)
  cBuffer := Space(nBytes)
  FRead( nHandle, @cBuffer, nBytes )
  FClose( nHandle )
  aData := Bin2Var(cBuffer)
  IF Valtype(aData) = 'A'
    oBrowse := _debugBrowseWindow( nWindow, @oDlg )
    oBrowse:dataSource := aData
    oBrowse:goBottom()
    oBrowse:forceStable()
  ENDIF
ENDIF

RETURN nil

* --------------------

STATIC FUNCTION _DebugSave( oBrowse, nWindow )

LOCAL GetList[0], GetOptions, cFileName, lStatus

cFileName := Space(70)

@ 0,0 DCSAY 'File Name to Save to:' SAYSIZE 0 SAYBOTTOM
@ 1,0 DCGET cFileName POPUP {|c|DC_PopFile(c,,,'Debug File to Save',,.t.)} VALID {||DC_ReadEmpty(cFileName)}

DCGETOPTIONS TABSTOP

DCREAD GUI FIT MODAL SETAPPWINDOW TITLE 'Save Debug to File' ;
   TO lStatus ADDBUTTONS ENTEREXIT NOAUTORESTORE OPTIONS GetOptions

IF lStatus
  DC_DebugBrowseSave( cFileName, nWindow)
ENDIF

RETURN nil

* --------------------

FUNCTION DC_DebugBrowseSave( cFileName, nWindow )

LOCAL oBrowse, oDlg, nHandle, cBuffer

DEFAULT nWindow := 1
DEFAULT cFileName := 'DCBDEBUG.XPF'
IF !'.' $ cFileName
  cFileName += '.XPF'
ENDIF
nHandle := FCreate(cFileName)
oBrowse := _debugBrowseWindow( nWindow, @oDlg )

cBuffer := Var2Bin( oBrowse:dataSource )

FWrite( nHandle, cBuffer )
FClose( nHandle )

RETURN nil

* --------------------

FUNCTION DC_DebugBrowseEnable( aEnable )

STATIC saEnable := nil // { 'EXPRESSDEBUG' }
LOCAL aOldEnable := saEnable
IF Valtype(aEnable) == 'A'
  saEnable := aEnable
ENDIF
RETURN aOldEnable

* --------------------

STATIC FUNCTION _ArrayToString( xValue )

LOCAL cString, cArray

IF Valtype(xValue) == 'A'
  cArray := DC_Array2String(xValue)
  cString := Strtran(cArray,'},','},;')
  IF Len(cString) > 300
    cString := Substr(cString,1,300)
  ENDIF
  RETURN cString
ENDIF

RETURN DC_XtoC(xValue)

* --------------------

FUNCTION DC_DebugWindowBrowse ( oDlg, nWindow, bEval, lAlwaysOnTop, oCallWindow )

LOCAL i, oBrowse, aData[0], aConfig, GetList[0], GetOptions, oStatTop, ;
      oToolBar, aWorkArea, nWidth, nHeight, nRow, nCol, nPointer, bColor, ;
      oContinueButton, bSortCol, bTip, oMenuGoto, aSaveOptions

PRIVATE __DCBDEBUG := .T.

aConfig := DC_DebugBrowseConfig(nWindow)

DCSTATUSBAR oStatTop HEIGHT 20 ALIGN DCGUI_ALIGN_TOP TYPE XBPSTATIC_TYPE_RAISEDBOX

bColor := {||_BrowseColor(DC_GetColArray(nil,oBrowse))}

@ 0,0 DCBROWSE oBrowse DATA aData ;
      PRESENTATION DC_BrowPresExpress() SIZE 400,100 ;
      HEADLINES 2 FONT DC_DebugWindowBrowseFont() PIXEL ;
      POINTER nPointer ;
      ITEMSELECTED {|a,b,o|_ShowData(o:dataSource[o:arrayElement],oBrowse,nPointer)} ;
      COLOR bColor ;
      NOSOFTTRACK ;
      SORTSCOLOR GRA_CLR_WHITE, GRA_CLR_RED ;
      SORTUCOLOR GRA_CLR_WHITE, GRA_CLR_DARKGRAY ;
      SORTUPBITMAP BITMAP_RD_UP_RED ;
      SORTDOWNBITMAP BITMAP_RD_DOWN_RED  ;
      FIT ;
      OPTIMIZE ;
      RESIZE DCGUI_RESIZE_RESIZEONLY ;
      RBSELECT ;
      RBDOWN BrowseMenuBlock(@oBrowse,nWindow)

bSortCol := {|a,n|_SortCol(aData,n)}

FOR i := 1 TO Len(aConfig[1])

  IF i == 3
    bTip := {|n|_ArrayToString(ATail(aData[n]))}
  ELSE
    bTip := nil
  ENDIF
  IF i == 2
    DCBROWSECOL ;
     HEADER 'b' WIDTH 2 ;
     DATA {||IIF(!Empty(DC_GetColArray(2,oBrowse)),'b','')} ;
     COLOR {||IIF(!Empty(DC_GetColArray(2,oBrowse)),{GRA_CLR_BLACK,GRA_CLR_YELLOW},nil)} ;
     PARENT oBrowse ;
     HFONT '12.Marlett' ;
     FONT '12.Marlett' ;
     SORT bSortCol
  ELSE
    DCBROWSECOL ELEMENT i HEADER aConfig[1,i] WIDTH aConfig[2,i] ;
     PICTURE IIF(i=1,'99999',nil) ;
     PARENT oBrowse DATATOOLTIP {||.t.} TIPBLOCK bTip ;
     SORT bSortCol
  ENDIF

NEXT

@ 0,0 DCTOOLBAR oToolBar SIZE 300,20 PARENT oStatTop BUTTONSIZE 80,20 PIXEL

DCADDBUTTON PARENT oToolBar CAPTION 'Print' ACTION {||DC_PrintBrowse(oBrowse)}

DCADDBUTTON CAPTION '<-Left' ;
   ACTION {||oBrowse:moveColumn(-1)}  ;
   FONT '8.Courier' ;
   WHEN {||oBrowse:colPos > 1} ;
   PARENT oToolBar

DCADDBUTTON CAPTION 'Right->' ;
   ACTION {||oBrowse:moveColumn(1)}  ;
   FONT '8.Courier' ;
   WHEN {||oBrowse:colPos < 10} ;
   PARENT oToolBar

DCADDBUTTON CAPTION 'Mark/GoTo' ;
   FONT '8.Courier' ;
   PARENT oToolBar ;
   ACTION {|a,b,o|oMenuGoTo:PopUp( o:setParent(), o:currentPos(), 2 , ;
                  XBPMENU_PU_DEFAULT + XBPMENU_PU_MOUSE_RBDOWN  ) } ;


DCADDBUTTON CAPTION 'Optimize All' ;
   ACTION {||oBrowse:optimize()} ;
   TOOLTIP 'Size ALL columns to optimize view of data;Double-click a column heading to optimize an individual column' ;
   SIZE 100,20 ;
   PIXEL ;
   FONT '8.Courier' ;
   PARENT oToolBar

DCADDBUTTON CAPTION 'Continue' ;
   ACTION {|a,b,o|oDlg:drawingArea:cargo[3] := .t., o:disable() } ;
   TOOLTIP 'Program paused!!!!!;Press this button to continue' ;
   EVAL {|o|o:disable()} ;
   PARENT oToolBar ;
   OBJECT oContinueButton

DCADDBUTTON CAPTION ;
     {||IIF( Empty(oDlg) .OR. !oDlg:drawingArea:cargo[4], ;
            'Disable Pause','Enable Pause')} ;
   ACTION {|a,b,o|oDlg:drawingArea:cargo[4] := !oDlg:drawingArea:cargo[4], ;
                  DC_GetRefresh(GetList,'OVERRIDE') } ;
   TOOLTIP {||IIF(!oDlg:drawingArea:cargo[4], ;
              'Press this button to Disable PAUSE in debug statements', ;
              'Press this button to Enable PAUSE in debug statements')} ;
   PARENT oToolBar ;
   ID 'OVERRIDE' ;
   SIZE 100, 20

DCADDBUTTON CAPTION 'Clear' ;
   ACTION {||ASize(aData,0),oBrowse:refreshAll()} ;
   TOOLTIP 'Clear the display' ;
   PARENT oToolBar

DCADDBUTTON CAPTION 'Save' ;
   ACTION {||_DebugSave(oBrowse,nWindow)} ;
   TOOLTIP 'Save the contents of this window' ;
   PARENT oToolBar

DCADDBUTTON CAPTION 'Restore' ;
   ACTION {||_DebugRestore(oBrowse,nWindow)} ;
   TOOLTIP 'Save the contents of this window' ;
   PARENT oToolBar

DCADDBUTTON CAPTION 'Suspend' ;
   ACTION {|x,y,o|x := oBrowse:setParent():cargo[5], ;
              x := !x, ;
              oBrowse:setParent():cargo[5] := x, ;
              o:setCaption(IIF(x,'Resume','Suspend'))} ;
   TOOLTIP 'Suspend or Resume capturing debug events' ;
   PARENT oToolBar

DCADDBUTTON CAPTION 'Dot-Prompt' ;
   ACTION {|x,y,o|PostAppEvent(xbeP_Keyboard,DC_DotHotKey(),,oCallWindow)} ;
   TOOLTIP 'Open a Dot-Prompt in the calling thread' ;
   PARENT oToolBar ;
   WHEN {||Valtype(oCallWindow)=='O'}

DCSUBMENU oMenuGoto PROMPT 'Goto Menu'

  DCMENUITEM 'Go To Row' PARENT oMenuGoto ACTION {||_DebugGotoRow(oBrowse)}
  DCMENUITEM 'Mark / Unmark Selected Row (F12)' PARENT oMenuGoto ;
    ACTION {||oBrowse:dataSource[oBrowse:arrayElement,2] := ;
              !oBrowse:dataSource[oBrowse:arrayElement,2], ;
              oBrowse:refreshCurrent()}
  DCMENUITEM 'Go to Marked Row' PARENT oMenuGoto ;
     ACTION {|n|n:=_DebugGotoMarked(oBrowse), ;
                IIF(!Empty(n),(oBrowse:arrayElement := n, oBrowse:refreshAll()),nil)}
  DCMENUITEM 'Show Marked Rows in New Window' PARENT oMenuGoto ACTION {||_DebugMarkedNewWindow(oBrowse)}

DCHOTKEY xbeK_F12 ;
    ACTION {||oBrowse:dataSource[oBrowse:arrayElement,2] := ;
              !oBrowse:dataSource[oBrowse:arrayElement,2], ;
              oBrowse:refreshCurrent()}

aWorkArea := DC_GetWorkArea()

nWidth  := 500
nHeight := 255
nRow    := AppDeskTop():currentSize()[2]-aWorkArea[4]
nCol    := aWorkArea[1]

aSaveOptions := DC_GetOptDefault()
DC_GetOptDefault({})

DCGETOPTIONS ;
   WINDOWROW nRow ;
   WINDOWCOL nCol ;
   WINDOWWIDTH nWidth ;
   WINDOWHEIGHT nHeight ;
   _ALWAYSONTOP lAlwaysOnTop ;
   RESIZE

DCREAD GUI ;
   OPTIONS GetOptions ;
   EXPRESS ;
   TITLE 'eXpress++ Debug Window #' + Alltrim(Str(nWindow)) ;
   EVAL {|o|IIF(Valtype(bEval)=='B',Eval(bEval,o),nil), ;
            o:resize := {|a,b,oDlg|_ResizeBrowse(oDlg, oBrowse)}, ;
            o:drawingArea:cargo := { oBrowse,oContinueButton,.f.,.f.,.f.}, ;
            oDlg := o, ;
            M->__DCBDEBUG := .F., ;
            DC_GetOptDefault(aSaveOptions) }

saDebugWindow[nWindow] := nil

RETURN nil

* --------------

FUNCTION DC_DebugWindowBrowseFont( cFont )

STATIC scFont := '10.Lucida Console Bold'

IF Valtype(cFont) == 'C'
  scFont := cFont
ENDIF

RETURN scFont

* --------------

STATIC FUNCTION _DebugGotoRow( oBrowse )

LOCAL lStatus, GetList[0], nRow := oBrowse:arrayElement

@ 0,0 DCSAY 'Go to Row#' GET nRow PICTURE '999999' SAYSIZE 0 SAYBOTTOM ;
   VALID {||nRow > 0 .AND. nRow <= Len(oBrowse:dataSource)}

DCREAD GUI FIT ADDBUTTONS TITLE 'Go to Row' MODAL TO lStatus

IF lStatus
  oBrowse:arrayElement := nRow
  oBrowse:refreshAll()
ENDIF

RETURN nil

* --------------

STATIC FUNCTION _DebugGotoMarked( oBrowse )

LOCAL GetList[0], lStatus, oBrowseMarked, aMarked[0], aData, nPointer := 1, ;
      i, GetOptions, nRow := 0

aData := oBrowse:dataSource
FOR i := 1 TO Len(aData)
  IF aData[i,2]
    Aadd(aMarked,aData[i])
  ENDIF
NEXT

IF Empty(aMarked)
  DC_WinAlert('No Marked rows!')
  RETURN nil
ENDIF

@ 0,0 DCBROWSE oBrowseMarked DATA aMarked SIZE 40,20 FIT ;
   ITEMSELECTED {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
   POINTER nPointer FONT '10.Lucida Console Bold' ;
   RESIZE DCGUI_RESIZE_RESIZEONLY

DCBROWSECOL ELEMENT 1 HEADER 'Row' WIDTH 4 PARENT oBrowseMarked PICTURE '999'
DCBROWSECOL ELEMENT 3 HEADER 'Data' WIDTH 20 PARENT oBrowseMarked
DCBROWSECOL ELEMENT 4 HEADER 'Source' WIDTH 20 PARENT oBrowseMarked

DCGETOPTIONS RESIZE

DCREAD GUI FIT ADDBUTTONS TITLE 'Go to Marked Row' MODAL ;
   SETAPPWINDOW TO lStatus OPTIONS GetOptions NOAUTORESTORE

IF lStatus
  nRow := aMarked[nPointer,1]
ENDIF

RETURN nRow

* --------------

STATIC FUNCTION _DebugMarkedNewWindow( oBrowse )

LOCAL nWindow, oNewBrowse, oThread, oDlg, i, aData, aMarked[0], nCount := 1

DEFAULT nWindow := Len(saDebugWindow) + 1

aData := oBrowse:dataSource
FOR i := 1 TO Len(aData)
  IF aData[i,2]
    Aadd(aMarked,AClone(aData[i]))
    ATail(aMarked)[1] := nCount++
    ATail(aMarked)[2] := .f.
  ENDIF
NEXT

IF Empty(aMarked)
  DC_WinAlert('No Marked rows!')
  RETURN nil
ENDIF

IF nWindow > Len(saDebugWindow)
  ASize(saDebugWindow,nWindow)
ENDIF

IF Valtype(saDebugWindow[nWindow]) = 'O'
  oDlg := saDebugWindow[nWindow]
ELSE
  oThread := Thread():new()
  Sleep(20)
  oThread:start( {||DC_DebugWindowBrowse(@oDlg,nWindow,nil,.f.)} )
  DO WHILE Valtype(oDlg) # 'O'
    Sleep(10)
  ENDDO
  saDebugWindow[nWindow] := oDlg
ENDIF

oNewBrowse := oDlg:drawingArea:cargo[1]
oNewBrowse:dataSource := aMarked
oNewBrowse:refreshAll()

RETURN nil

* --------------

STATIC PROCEDURE _SortCol( aData, nColumn )

ASort( aData,,,{|x,y|x[nColumn] < y[nColumn]} )

RETURN

* --------------

STATIC FUNCTION _ResizeBrowse( oDlg, oBrowse )

oBrowse:setPos({10,10})

oBrowse:setSize({oDlg:drawingArea:currentSize()[1]-20, ;
                 oDlg:drawingArea:currentSize()[2]-40})

RETURN nil

* --------------

STATIC FUNCTION BrowseMenuBlock( oBrowse, nThread )

RETURN {|x,y,z,o|o := BrowseMenu( oBrowse, nThread ), ;
                                o:popup( nil, x, 1 , ;
                                XBPMENU_PU_DEFAULT + XBPMENU_PU_MOUSE_RBDOWN ) }

* -------------

STATIC FUNCTION BrowseMenu( oBrowse, nThread )

LOCAL GetList[0], i

IF Valtype(soMenu) # 'O' .OR. soMenu:status()<=0 .OR. soBrowse # oBrowse

  IF Valtype(soMenu) = 'O'
    soMenu := nil
  ENDIF

  soBrowse := oBrowse

  DCSUBMENU soMenu

    DCMENUITEM 'Open Dot-Prompt in this thread' PARENT soMenu ;
        ACTION {||PostAppEvent(DCGUI_EVENT_ACTION, ;
               {||DllLoad('dclip1.dll'),&('DC_Dot(.f.)')},,_ThreadObject(nThread,.t.))} ;
        WHEN {||!Empty(_ThreadObject(nThread,.f.))}

  DCREAD GUI ;
    PARENT oBrowse ;
    EXIT

ENDIF

RETURN soMenu

* --------------

STATIC FUNCTION _ThreadObject( nThread, lVerbose )

LOCAL aThreadInfo, oDlg, nFound

aThreadInfo := ThreadInfo(THREADINFO_TID      + ;
                          THREADINFO_SYSTHND  + ;
                          THREADINFO_FUNCINFO + ;
                          THREADINFO_TOBJ)

nFound := AScan(aThreadInfo,{|a|a[1]==nThread})
IF nFound > 0
  oDlg := aThreadInfo[nFound,5]:cargo
ENDIF

IF Valtype(oDlg) == 'O' .AND. oDlg:isDerivedFrom('XbpPartHandler')
  RETURN oDlg
ELSEIF lVerbose
  DC_WinAlert('Cannot post a message to this thread: ' + DC_Xtoc(nThread))
ENDIF

RETURN nil

* --------------

STATIC FUNCTION _ShowData( aData, oBrowse, nPointer )

LOCAL xData := Atail(aData), oThread, nColumn, cStackInfo, cProcName, ;
      cProcLine, aStack, aPointers

IF oBrowse:colPos > 5  .AND. nPointer > 0 .AND. IsFunction('DC_CallEditor')
  nColumn := oBrowse:colPos
  aData := oBrowse:dataSource
  cStackInfo := aData[nPointer,nColumn]
  cStackInfo := Strtran(cStackInfo,'(B)','')
  cProcName := Substr(cStackInfo,1,At('(',cStackInfo)-1)
  cProcLine := Substr(cStackInfo,At('(',cStackInfo))
  cProcLine := Strtran(cProcLine,'(','')
  cProcLine := Strtran(cProcLine,')','')
  aStack := { { cProcName, Val(cProcLine), IsFunction(cProcName) } }
  aPointers := { 1 }
  &('DC_CallEditor')( aStack, aPointers )
ELSEIF Valtype(xData) == 'A'
  oThread := Thread():new()
  Sleep(20)
  oThread:Start({||DC_ArrayView(xData,,,.f.)})
ELSEIF Valtype(xData) == 'O'
  IF IsMethod(xData,'CHILDLIST') .AND. !Empty(xData:childList())
    oThread := Thread():new()
    Sleep(10)
    oThread:Start({||DC_ArrayView(xData,,,.f.)})
  ELSE
    IF xData:isDerivedFrom('AutomationObject')
      DC_DisplayProperties(xData)
    ELSE
      oThread := Thread():new()
      Sleep(20)
      oThread:Start({||DC_InspectObject(xData,,,.f.)})
    ENDIF
  ENDIF
ELSEIF Valtype(xData) $ 'CM'
  DC_GuiMemoEdit(xData)
ELSEIF Valtype(xData) == 'D'
  DC_PopDate(xData)
ELSEIF Valtype(xData) == 'N'
  DC_PopCalc(xData)
ENDIF

RETURN nil

* ------------------

STATIC FUNCTION _BrowseColor( aData )

LOCAL xColor, aColor

IF Empty(aData)
  RETURN nil
ENDIF

xColor := aData[Len(aData)-1]
IF Valtype(xColor) == 'B'
  aColor := Eval(xColor)
ELSEIF Valtype(xColor) == 'A'
  aColor := xColor
ENDIF

RETURN aColor

* -----------

CLASS testing

EXPORTED:

VAR abc
VAR def

INLINE METHOD Init()

::abc := 'testing abc'
::def := 'testing def'

RETURN self

ENDCLASS

* ---------------

GETSETFUNCTION DC_DefDir DEFAULT 'c:\expd19\ClassDef\'

* ---------------

FUNCTION DC_DisplayProperties( oAutomationObject )

LOCAL i, cInterfaceName, oOwner, aProperties[0], aDir, aDefs, ;
      GetList[0], GetOptions, oStatic, nRow, nWidth, nHeight, ;
      bError, lStatus, oTab1, oTab2, oTab3, oTab4, oTab5, oTab6, ;
      cParent

IF Valtype(oAutomationObject) # 'O' .OR. !oAutomationObject:isDerivedFrom('AutomationObject')
  DC_Winalert( 'DC_DisplayProperties() parameter is not an AutomationObject')
  RETURN .f.
ENDIF

cInterfaceName := Strtran(oAutomationObject:interfaceName,'_D','')

oOwner := oAutomationObject:owner
aDir := Directory( DC_DefDir()+'\*.def', cInterfaceName )

FOR i := 1 TO Len(aDir)
  aDefs := DC_ObjectDefArray( aDir[i,1], cInterfaceName )
  IF !Empty(aDefs[2])
    EXIT
  ENDIF
NEXT

IF Empty(aDefs) .OR. Empty(aDefs[2])
  DC_Winalert( 'No Class defs for ' + cInterfaceName + ' in ' + DC_DefDir() )
  RETURN .f.
ENDIF

// @ 0,0 DCSAY 'Class Name:' FONT '8.Helv Bold'
@ 0,0 DCSAY 'Class Name:' FONT Dc_BaseFont()  // Jack Duijf 17-07-2014
@ DCGUI_ROW, DCGUI_COL + 10 DCSAY cInterfaceName SAYLEFTBOTTOM SAYSIZE 0

// @ 1,0 DCSAY 'Owner:' FONT '8.Helv Bold'
@ 1,0 DCSAY 'Owner:' FONT Dc_BaseFont(,,.T.)  // Jack Duijf 17-07-2014

IF oOwner == nil
  @ DCGUI_ROW, DCGUI_COL + 10 DCSAY '<Unknown>' ;
      COLOR GRA_CLR_DARKGREEN SAYSIZE 30 FONT '10.Lucida Console'
ELSEIF oOwner:isDerivedFrom('AutomationObject')
  @ DCGUI_ROW, DCGUI_COL + 10 DCSAY Strtran(oOwner:interfaceName,'_D','') ;
      HYPERLINK {||DC_DisplayProperties(oOwner)} SAYLEFTBOTTOM ;
      COLOR GRA_CLR_DARKGREEN SAYSIZE 30 ;
      FONT '10.Lucida Console'
ELSE
  @ DCGUI_ROW, DCGUI_COL + 10 DCSAY oOwner:className() ;
      HYPERLINK {||DC_InspectObject(oOwner)} SAYLEFTBOTTOM ;
      COLOR GRA_CLR_DARKGREEN SAYSIZE 30 FONT '10.Lucida Console'
ENDIF

nHeight := Len(aDefs[2])
nHeight := Max(nHeight,Len(aDefs[3]))
nHeight := Max(nHeight,Len(aDefs[4]))

nHeight := Min(nHeight,22)

@ 2.5, 0 DCTABPAGE oTab1 CAPTION 'Properties' SIZE 100, nHeight + 3 COLOR GRA_CLR_WHITE ID 'TAB1' WHEN {||Len(aDefs[2])>0}
@ 0, 0 DCTABPAGE oTab2 CAPTION 'Properties(2)' RELATIVE oTab1 COLOR GRA_CLR_WHITE ID 'TAB2' WHEN {||Len(aDefs[2])>22}
@ 0, 0 DCTABPAGE oTab3 CAPTION 'Methods' RELATIVE oTab2 COLOR GRA_CLR_WHITE ID 'TAB3' WHEN {||Len(aDefs[3])>0}
@ 0, 0 DCTABPAGE oTab4 CAPTION 'Methods(2)' RELATIVE oTab3 COLOR GRA_CLR_WHITE ID 'TAB4' WHEN {||Len(aDefs[3])>22}
@ 0, 0 DCTABPAGE oTab5 CAPTION 'Events' RELATIVE oTab4 COLOR GRA_CLR_WHITE ID 'TAB5' WHEN {||Len(aDefs[4])>0}
@ 0, 0 DCTABPAGE oTab6 CAPTION 'Events(2)' RELATIVE oTab5 COLOR GRA_CLR_WHITE ID 'TAB6' WHEN {||Len(aDefs[4])>22}

nRow := 2
nWidth := 80
bError := ErrorBlock({|e|Break(e)})

* --- Properties ---
cParent := 'TAB1'
FOR i := 1 TO Len(aDefs[2])
//   nWidth := Max(nWidth,DC_GraQueryTextBox(aDefs[2,i],'8.Helv')[1])
//  @ nRow++,2 DCSAY aDefs[2,i] + ':' FONT '8.Helv Bold' PARENTID cParent
  nWidth := Max(nWidth,DC_GraQueryTextBox(aDefs[2,i],Dc_BaseFont())[1])  // Jack Duijf 17-07-2014
  @ nRow++,2 DCSAY aDefs[2,i] + ':' FONT Dc_BaseFont(,,.T.) PARENTID cParent  // Jack Duijf 17-07-2014
  lStatus := .f.
  BEGIN SEQUENCE
  IF Valtype(oAutomationObject:&(aDefs[2,i])) == 'O'
    @ DCGUI_ROW, DCGUI_COL + 10 ;
      DCSAY oAutomationObject:getProperty(aDefs[2,i]):interfaceName ;
      PARENTID cParent ;
      COLOR GRA_CLR_BLUE, GRA_CLR_WHITE SAYLEFTBOTTOM FONT '10.Lucida Console' ;
      HYPERLINK _HyperlinkBlock(oAutomationObject:getProperty(aDefs[2,i])) SAYSIZE 30
  ELSE
    @ DCGUI_ROW, DCGUI_COL + 10 ;
      DCSAY DC_XtoC(oAutomationObject:&(aDefs[2,i])) ;
      PARENTID cParent ;
      COLOR GRA_CLR_BLACK, GRA_CLR_WHITE SAYLEFTBOTTOM SAYSIZE 0
  ENDIF
  lStatus := .t.
  END SEQUENCE
  IF !lStatus
    @ DCGUI_ROW, DCGUI_COL + 10 DCSAY 'Click here to give this property a value' ;
      COLOR GRA_CLR_RED, GRA_CLR_WHITE SAYLEFTBOTTOM SAYSIZE 60 PARENTID cParent ;
      HYPERLINK _ErrorHyperLinkBlock(oAutomationObject,aDefs[2,i])
  ENDIF
  IF nRow > 22
    cParent := 'TAB2'
    nRow := 2
  ENDIF
NEXT

* --- Methods ---
nRow := 2
cParent := 'TAB3'
FOR i := 1 TO Len(aDefs[3])
  nWidth := Max(nWidth,DC_GraQueryTextBox(aDefs[3,i],Dc_BaseFont(,,.T.))[1])
  @ nRow++,2 DCSAY aDefs[3,i] FONT Dc_BaseFont(,,.T.) PARENTID cParent SAYLEFT
  IF nRow > 22
    cParent := 'TAB4'
    nRow := 2
  ENDIF
NEXT

* --- Events ---
nRow := 2
cParent := 'TAB5'
FOR i := 1 TO Len(aDefs[4])
  nWidth := Max(nWidth,DC_GraQueryTextBox(aDefs[4,i],Dc_BaseFont())[1])
  @ nRow++,2 DCSAY aDefs[4,i] + ':' FONT Dc_BaseFont(,,.T.) PARENTID cParent
  lStatus := .f.
  BEGIN SEQUENCE
  @ DCGUI_ROW, DCGUI_COL + 10 ;
      DCSAY DC_XtoC(oAutomationObject:&(aDefs[4,i])) ;
      PARENTID cParent ;
      COLOR GRA_CLR_BLACK, GRA_CLR_WHITE SAYLEFTBOTTOM SAYSIZE 0
  lStatus := .t.
  END SEQUENCE
  IF !lStatus
    @ DCGUI_ROW, DCGUI_COL + 10 DCSAY 'Cannot Display Value (bug in Xbase++)' ;
      COLOR GRA_CLR_RED, GRA_CLR_WHITE SAYLEFTBOTTOM SAYSIZE 0 PARENTID cParent
  ENDIF
  IF nRow > 22
    cParent := 'TAB6'
    nRow := 2
  ENDIF
NEXT

ErrorBlock(bError)

DCGETOPTIONS SAYWIDTH nWidth+40 SAYRIGHTBOTTOM ;
     SAYFONT '10.Lucida Console'

DCREAD GUI FIT TITLE cInterfaceName + ' properties' ;
   MODAL OPTIONS GetOptions SETAPPWINDOW

RETURN .t.

* ----------

STATIC FUNCTION _HyperlinkBlock( oObject )

RETURN {||DC_DisplayProperties(oObject)}

* ----------

STATIC FUNCTION _ErrorHyperlinkBlock( oObject, cProperty )

RETURN {||ChoosePropertyValue(oObject,cProperty)}

* ----------

STATIC FUNCTION ChoosePropertyValue( oObject, cProperty )

LOCAL GetList[0], nValue := 0, lStatus, xReturn, oError

@ 0,0 DCSAY 'Enter Value' GET nValue PICT '99' SAYSIZE 0 SAYBOTTOM

DCREAD GUI FIT ADDBUTTONS ENTEREXIT ;
   TITLE 'Pass a Value to Property' TO lStatus MODAL

IF lStatus
  oError := ErrorBlock({|e|_TrapError(e)})
  BEGIN SEQUENCE
  xReturn := oObject:getProperty(cProperty,nValue)
  IF Valtype(xReturn) == 'O'
    DC_DisplayProperties(xReturn)
  ELSE
    DCMSGBOX 'Return value: ' + DC_XtoC(xReturn)
  ENDIF
  END SEQUENCE
  ErrorBlock(oError)
ENDIF

RETURN nil

* -----------

STATIC FUNCTION _TrapError(e)

DC_WinAlert('Invalid Parameter Value')
BREAK

RETURN nil

* ---------------

FUNCTION DC_ObjectDefArray( cOCX, cClassName )

LOCAL aArray[0], aDefs[0], nHandle, cLine, i, aTokens

IF !'.' $ cOCX
  cOCX += '.def'
ENDIF

nHandle := DC_TxtOpen( DC_DefDir() + '\' + cOCX )

IF nHandle <= 0
  RETURN aArray
ENDIF

AAdd( aDefs, { cOCX, cClassName, ' '} )
AAdd( aDefs, {} ) // Properties
AAdd( aDefs, {} ) // Methods
AAdd( aDefs, {} ) // Events

* ---- Properties and Methods ----

DC_TxtFind( nHandle, 'CLASS ' + cClassName+Chr(13), .f. )
DC_TxtSkip( nHandle,1 )
DO WHILE !DC_TxtEof(nHandle)
   cLine := DC_TxtLine(nHandle)
   DC_TxtSkip(nHandle,1)
   IF cLine = 'ENDCLASS'
     EXIT
   ENDIF
   AAdd( aArray, Alltrim(cLine))
ENDDO

FOR i := 1 TO Len(aArray)
  IF Left(aArray[i],6 ) = 'METHOD'
    AAdd( aDefs[3], Substr(aArray[i],8) )
  ELSEIF Left(aArray[i],6 ) = 'ACCESS' .OR. Left(aArray[i],6) == 'ASSIGN'
    aTokens := DC_TokenArray(aArray[i],' ')
    IF AScan(aDefs[2],aTokens[5]) == 0
      AAdd( aDefs[2], aTokens[5] )
    ENDIF
  ENDIF
NEXT

* ---- Events ----
ASize(aArray,0)
DC_TxtFind( nHandle, 'CLASS _D' + cClassName+'Events'+Chr(13), .f. )
DC_TxtSkip( nHandle,1 )
DO WHILE !DC_TxtEof(nHandle)
   cLine := DC_TxtLine(nHandle)
   DC_TxtSkip(nHandle,1)
   IF cLine = 'ENDCLASS'
     EXIT
   ENDIF
   AAdd( aArray, Alltrim(cLine))
ENDDO

FOR i := 1 TO Len(aArray)
  IF Left(aArray[i],6 ) = 'METHOD'
    AAdd( aDefs[4], Substr(aArray[i],8) )
  ENDIF
NEXT

DC_TxtClose(nHandle)

RETURN aDefs

* ------------------

FUNCTION DC_WinDebug( xValue )

STATIC debugCall := nil

// Windows Debug-System
IF debugCall = NIL
  debugCall := DllPrepareCall( "kernel32.dll", DLL_STDCALL, "OutputDebugStringA" )
ENDIF

DllExecuteCall(debugCall, var2char(xValue))

RETURN nil

